"use strict";
// Copyright (c) Mito
// Distributed under the terms of the Modified BSD License.
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const PivotTaskpane_1 = require("./PivotTaskpane");
const SmallSelect_1 = __importStar(require("../../elements/SmallSelect"));
const PivotTableValueAggregationCard_1 = __importDefault(require("./PivotTableValueAggregationCard"));
// import css
require("../../../../css/pivot-table-key-selection.css");
/*
  A custom component used in the pivot table which lets the
  user select column headers to add to the row or column keys
*/
const PivotTableValueSelection = (props) => {
    // TODO: Put these in order of selection so that the new one is at the top so that the user can easily change its aggregation method
    const PivotTableValueAggregationCards = [];
    for (const columnHeader of Object.keys(props.aggregatedValuesInSection)) {
        PivotTableValueAggregationCards.push((react_1.default.createElement(PivotTableValueAggregationCard_1.default, { key: columnHeader, columnHeader: columnHeader, aggregationType: props.aggregatedValuesInSection[columnHeader], editValueAggregationSelection: props.editValueAggregationSelection })));
    }
    // get column headers that are not yet aggregated
    const selectableColumnHeaders = props.columnHeaders.filter(x => !Object.keys(props.aggregatedValuesInSection).includes(x));
    /*
      Function passed to the SmallSelect so that when the user selects a
      key to add, it can communicate the addition to the pivot table state

      Note: we use this wrapper around the editColumnKeySelection function so that
      we can conform with the interface of the SmallSelect whose setValue function
      only takes a string as a param
    */
    function addAggregatedValue(columnHeader) {
        props.editValueAggregationSelection(columnHeader, PivotTaskpane_1.SelectionOperation.ADD, PivotTaskpane_1.AggregationType.COUNT);
    }
    return (react_1.default.createElement("div", null,
        react_1.default.createElement("div", { className: 'pivot-taskpane-section-header-div' },
            react_1.default.createElement("p", { className: 'default-taskpane-body-section-title-text' }, "Values"),
            react_1.default.createElement(SmallSelect_1.default, { startingValue: 'add', optionsArray: selectableColumnHeaders, setValue: addAggregatedValue, titleColor: SmallSelect_1.TitleColor.BLUE })),
        PivotTableValueAggregationCards));
};
exports.default = PivotTableValueSelection;
//# sourceMappingURL=PivotTableValueSelection.js.map